package nc.ui.gl.multibooksdef;

import java.awt.BorderLayout;
import java.awt.Insets;
import java.awt.LayoutManager;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import javax.swing.JFrame;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.table.TableColumn;
import javax.swing.table.TableColumnModel;
import javax.swing.table.TableModel;
import nc.bs.logging.Log;
import nc.ui.gl.multibooksdef.MultiFormatTableModel;
import nc.ui.pub.beans.UIPanel;
import nc.ui.pub.beans.UITablePane;
import nc.ui.pub.beans.table.VOTableModel;
import nc.vo.gl.multibooks.MultiFormatVO;

public class ChartUi extends UIPanel implements PropertyChangeListener, ListSelectionListener {

   private TableModel m_tableModel = null;
   private nc.ui.glpub.IChartModel m_charModel = null;
   private UITablePane ivjMultiColList = null;


   public ChartUi() {
      this.initialize();
   }

   public ChartUi(LayoutManager p0) {
      super(p0);
   }

   public ChartUi(LayoutManager p0, boolean p1) {
      super(p0, p1);
   }

   public ChartUi(boolean p0) {
      super(p0);
   }

   public UITablePane getMultiColList() {
      if(this.ivjMultiColList == null) {
         try {
            this.ivjMultiColList = new UITablePane();
            this.ivjMultiColList.setName("MultiColList");
         } catch (Throwable var2) {
            this.handleException(var2);
         }
      }

      return this.ivjMultiColList;
   }

   private TableModel getTableModel() {
      if(this.m_tableModel == null) {
         try {
            this.m_tableModel = new MultiFormatTableModel(MultiFormatVO.class);
         } catch (Exception var2) {
            Log.getInstance(this.getClass()).error(var2);
         }
      }

      return this.m_tableModel;
   }

   private void handleException(Throwable exception) {
      Log.getInstance(this.getClass()).info("--------- 未捕捉到的异常 ---------");
      exception.printStackTrace(System.out);
   }

   private void initialize() {
      try {
         this.setName("ChartUi");
         this.setLayout(new BorderLayout());
         this.setSize(760, 387);
         this.add(this.getMultiColList(), "Center");
      } catch (Throwable var2) {
         this.handleException(var2);
      }

      this.initTable();
   }

   private void initTable() {
      this.getMultiColList().getTable().setModel(this.getTableModel());
      this.getMultiColList().getTable().setSelectionMode(0);
      this.getMultiColList().getTable().setAutoResizeMode(0);
      this.getMultiColList().getTable().getSelectionModel().addListSelectionListener(this);
      TableColumnModel cm = this.getMultiColList().getTable().getColumnModel();
      TableColumn tc = cm.getColumn(0);
      tc.setPreferredWidth(360);
      tc = cm.getColumn(1);
      tc.setPreferredWidth(350);
   }

   public static void main(String[] args) {
      try {
         JFrame exception = new JFrame();
         ChartUi aChartUi = new ChartUi();
         exception.setContentPane(aChartUi);
         exception.setSize(aChartUi.getSize());
         exception.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
               System.exit(0);
            }
         });
         exception.show();
         Insets insets = exception.getInsets();
         exception.setSize(exception.getWidth() + insets.left + insets.right, exception.getHeight() + insets.top + insets.bottom);
         exception.setVisible(true);
      } catch (Throwable var4) {
         System.err.println("nc.ui.pub.beans.UIPanel 的 main() 中发生异常");
         var4.printStackTrace(System.out);
      }

   }

   public void propertyChange(PropertyChangeEvent evt) {
      MultiFormatVO tempVO;
      if(evt.getPropertyName().equals("addvo")) {
         tempVO = (MultiFormatVO)evt.getNewValue();
         ((VOTableModel)this.getTableModel()).addVO(tempVO);
      } else if(evt.getPropertyName().equals("modifyvo")) {
         tempVO = (MultiFormatVO)evt.getNewValue();
         ((VOTableModel)this.getTableModel()).updateVO(tempVO);
      } else if(evt.getPropertyName().equals("deletevo")) {
         tempVO = (MultiFormatVO)evt.getNewValue();
         ((VOTableModel)this.getTableModel()).removeVO(tempVO);
      } else if(evt.getPropertyName().equals("removeall")) {
         ((VOTableModel)this.getTableModel()).clearTable();
      }

   }

   public void refresh() {
   }

   public void removeChartModel(nc.ui.glpub.IChartModel charModel) {
      this.m_charModel = null;
   }

   public void setChartModel(nc.ui.glpub.IChartModel charModel) {
      this.m_charModel = charModel;
   }

   public void valueChanged(ListSelectionEvent e) {
      try {
         if(e.getSource() == this.getMultiColList().getTable().getSelectionModel() && this.getMultiColList().getTable().getSelectedRow() >= 0) {
            this.m_charModel.setCurrentIndex(this.getMultiColList().getTable().getSelectedRow());
         }
      } catch (Exception var3) {
         Log.getInstance(this.getClass()).error(var3);
      }

   }
}
